<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des régions n'ont pas pu être chargées."
    />
    <template v-else-if="regionsCounts">
      <h2 class="fr-h5">Régions</h2>
      <StatsList
        v-if="regionsCounts.length"
        :total-count="beneficiaryCount"
        :stats="regionsCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des régions.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: regionsCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData('regionsCounts', loadRegionsCounts, {
    server: false
  })

  watch(() => props.filters, refresh)

  async function loadRegionsCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'region',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const regionsResCounts = res.data.data.map(region => ({
        key: region.region,
        label: region.region || 'Non renseigné',
        count: parseInt(region.countDistinct.id)
      }))
      regionsResCounts.sort((a, b) => b.count - a.count)
      return regionsResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
